VERSION 4.00
Begin VB.Form frmCallbacks 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "VBMax Electronic Message Demo - Callbacks"
   ClientHeight    =   600
   ClientLeft      =   60
   ClientTop       =   2565
   ClientWidth     =   9540
   Height          =   1005
   Icon            =   "Callbacks.frx":0000
   Left            =   0
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   600
   ScaleWidth      =   9540
   Top             =   2220
   Width           =   9660
   Begin VB.PictureBox picDisplay 
      Height          =   510
      Left            =   30
      ScaleHeight     =   450
      ScaleWidth      =   9435
      TabIndex        =   0
      Top             =   60
      Width           =   9495
   End
End
Attribute VB_Name = "frmCallbacks"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Dim moEDisp As New CElectronicDisplay


Private Sub Form_Load()

    Move (Screen.Width - Width) \ 2, (Screen.Height - Height) \ 2
    
    With moEDisp
        .BackColor = &H800000
        .ForeColor = &HFFFF00
        .NotifyWhenFinished = True
        .NotifyDelay = 0
        .Effect = gnEFFECT_STATIC
        Set .Container = picDisplay
        .Caption = " "
    End With
    
End Sub

Private Sub Form_Unload(Cancel As Integer)
    moEDisp.Shutdown
    Set moEDisp = Nothing
    Set frmCallbacks = Nothing
End Sub

Public Sub VBMaxElectronicDisplay_Finished(roEDisp As CElectronicDisplay) 'Called-back routine
Static nCounter As Integer

    nCounter = nCounter + 1
    
    With moEDisp
        Select Case nCounter
            Case 1:  Display gnEFFECT_SLIDE_FROM_TOP_CENTER, "With callbacks you can ..."
            Case 2:  Display gnEFFECT_SLIDE_TO_BOTTOM_CENTER
            Case 3:  Display gnEFFECT_SLIDE_FROM_TOP_LEFT, "Control the display, "
            Case 4:  Display gnEFFECT_SLIDE_TO_BOTTOM_RIGHT
            Case 5:  Display gnEFFECT_BUILD_FROM_LEFT_AND_RIGHT, "Know when an effect has finished."
            Case 6:  Display gnEFFECT_WIPE_FROM_LEFT_AND_RIGHT
            Case 7:  Display gnEFFECT_BUILD_TO_LEFT_AND_RIGHT, "Use them for such things as"
            Case 8:  Display gnEFFECT_WIPE_TO_TOP_AND_BOTTOM
            Case 9:  Display gnEFFECT_BUILD_FROM_TOP_AND_BOTTOM, "Changing the message"
            Case 10: Display gnEFFECT_WIPE_FROM_TOP_AND_BOTTOM
            Case 11:
                     If .ForeColor = vbYellow Then
                         .ForeColor = &HFFFF00
                     Else
                         .ForeColor = vbYellow
                     End If
                     Display gnEFFECT_BUILD_TO_TOP_AND_BOTTOM, "Or changing the colors"
            Case 12: Display gnEFFECT_WIPE_TO_LEFT_AND_RIGHT
            Case 13: Display gnEFFECT_SLIDE_FROM_BOTTOM_CENTER, "Combining different effects"
            Case 14: Display gnEFFECT_SLIDE_TO_BOTTOM_CENTER
            Case 15: Display gnEFFECT_SLIDE_FROM_BOTTOM_CENTER, "Makes the display more interesting"
            Case 16: Display gnEFFECT_WIPE_FROM_BOTTOM
            Case 17: Display gnEFFECT_BUILD_FROM_TOP, "Draw attention to your words"
            Case 18: .Cls
                     .flashcount = 4
                     Display gnEFFECT_FLASH, "~~~ Get your message across ~~~"
            Case 19: .Interval = 1
                     .ScrollAmount = gnENTIRE_CHARACTER
                     .Interval = 125
                     Display gnEFFECT_SCROLL, "Just set NotifyWhenFinished = True and add this subroutine to your form:  VBMaxElectronicDisplay_Finished  "
            Case 20: Display gnEFFECT_WIPE_FROM_LEFT
            Case 21: Display gnEFFECT_BUILD_FROM_RIGHT, "See the example in this form."
            Case 22: Display gnEFFECT_WIPE_FROM_RIGHT
                     nCounter = 0
        End Select
    End With

End Sub

Private Sub Display(rnEffect As Integer, Optional rvCaption As Variant)

    With moEDisp
        If IsMissing(rvCaption) Then
            .NotifyDelay = 0
            .Effect = rnEffect
        Else
            .NotifyDelay = 3
            .Effect = rnEffect
            .Caption = rvCaption
        End If
    End With

End Sub

