//----------------------------------------------------------------------------
// Smtp.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: Smtp.pas
//----------------------------------------------------------------------------
#ifndef SmtpHPP
#define SmtpHPP
//----------------------------------------------------------------------------
#include <mailutil.hpp>
#include <mailbase.hpp>
#include <Mime.hpp>
#include <UUCode.hpp>
#include <DsgnIntf.hpp>
#include <ExtCtrls.hpp>
#include <WinSock.hpp>
#include <Dialogs.hpp>
#include <Forms.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <SysUtils.hpp>
#include <System.hpp>
namespace Smtp
{
//-- type declarations -------------------------------------------------------
enum TStatus { msIdle, msConnecting, msLogIn, msLogOut, msHeaders, msEnvelope, msBody, msAttachment, 
	msCancel, msEnCode };

enum TEncoding { etUU, etMIME };

enum TCharSet { csUSASCII, csISO8859 };

enum TPriority { ptLow, ptNormal, ptHigh };

class __declspec(delphiclass) TSMTP;
class __declspec(pascalimplementation) TSMTP : public Mailbase::TMailBase
{
	typedef Mailbase::TMailBase inherited;
	
private:
	System::AnsiString FFrom;
	System::AnsiString FRecipient;
	System::AnsiString FSubject;
	Classes::TStrings* FBody;
	Classes::TStrings* FCC;
	Classes::TStrings* FBCC;
	TStatus FStatus;
	int FProgress;
	Classes::TStrings* FAttachments;
	TEncoding FEncoding;
	TCharSet FCharSet;
	bool FUseDomainAddress;
	bool FReturnReceipt;
	TPriority FPriority;
	Classes::TNotifyEvent FOnStatusChange;
	Classes::TNotifyEvent FOnProgress;
	void __fastcall SetBody(Classes::TStrings* Value);
	void __fastcall SetCC(Classes::TStrings* Value);
	void __fastcall SetBCC(Classes::TStrings* Value);
	void __fastcall SetCharSet(TCharSet Value);
	void __fastcall SetEncoding(TEncoding Value);
	void __fastcall SetAttachments(Classes::TStrings* Value);
	void __fastcall DoStatusChange(System::TObject* Sender);
	void __fastcall DoProgress(System::TObject* Sender);
	void __fastcall DummyStatusChange(System::TObject* Sender);
	
protected:
	Classes::TList* UULinesList;
	System::AnsiString UniqueID;
	bool Error;
	Mime::TBase64* Base64;
	Mime::TQuotedPrintable* QP;
	Uucode::TUUCode* UU;
	void __fastcall PrepareUULines(void);
	void __fastcall PrepareMIMELines(void);
	void __fastcall EncodeBody(void);
	void __fastcall SendEnvelope(void);
	void __fastcall EncodeAttachments(void);
	void __fastcall CheckForErrors(const System::AnsiString s);
	void __fastcall RecvData(void);
	void __fastcall SendBody(void);
	virtual void __fastcall SendHeaders(void);
	void __fastcall SendData(const System::AnsiString s);
	void __fastcall MIMEProgress(System::TObject* Sender);
	void __fastcall UUCodeProgress(System::TObject* Sender);
	virtual void __fastcall ReInit(void);
	System::AnsiString __fastcall SenderDomain(void);
	
public:
	__fastcall virtual TSMTP(Classes::TComponent* AOwner);
	__fastcall virtual ~TSMTP(void);
	virtual void __fastcall Open(void);
	void __fastcall LogIn(void);
	void __fastcall LogOut(void);
	void __fastcall Send(void);
	void __fastcall SendSingleMessage(void);
	virtual void __fastcall Cancel(void);
	__property TStatus Status = {read=FStatus, nodefault};
	__property int Progress = {read=FProgress, nodefault};
	
__published:
	__property Classes::TStrings* Attachments = {read=FAttachments, write=SetAttachments, nodefault};
	__property System::AnsiString From = {read=FFrom, write=FFrom, nodefault};
	__property System::AnsiString Recipient = {read=FRecipient, write=FRecipient, nodefault};
	__property Classes::TStrings* CC = {read=FCC, write=SetCC, nodefault};
	__property Classes::TStrings* BCC = {read=FBCC, write=SetBCC, nodefault};
	__property System::AnsiString Subject = {read=FSubject, write=FSubject, nodefault};
	__property Classes::TStrings* Body = {read=FBody, write=SetBody, nodefault};
	__property TEncoding Encoding = {read=FEncoding, write=SetEncoding, default=1};
	__property TCharSet CharSet = {read=FCharSet, write=SetCharSet, nodefault};
	__property bool ReturnReceipt = {read=FReturnReceipt, write=FReturnReceipt, default=0};
	__property TPriority Priority = {read=FPriority, write=FPriority, default=1};
	__property bool UseDomainAddress = {read=FUseDomainAddress, write=FUseDomainAddress, default=1};
	__property DefaultPort ;
	__property Classes::TNotifyEvent OnStatusChange = {read=FOnStatusChange, write=FOnStatusChange};
	__property Classes::TNotifyEvent OnProgress = {read=FOnProgress, write=FOnProgress};
};

//-- var, const, procedure ---------------------------------------------------
extern void __fastcall Register(void);

}	/* namespace Smtp */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Smtp;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// Smtp
