//----------------------------------------------------------------------------
// UUCode.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: UUCode.pas
//----------------------------------------------------------------------------
#ifndef UUCodeHPP
#define UUCodeHPP
//----------------------------------------------------------------------------
#include <Dialogs.hpp>
#include <Forms.hpp>
#include <SysUtils.hpp>
#include <Classes.hpp>
#include <System.hpp>
namespace Uucode
{
//-- type declarations -------------------------------------------------------
enum TCodeMethod { cdUU, cdXX };

typedef Byte T45Bytes[45];

typedef Byte T60Bytes[90];

typedef Byte TBuffer[65520];

typedef bool T24Bits[361];

class __declspec(delphiclass) EUUInvalidCharacter;
class __declspec(pascalimplementation) EUUInvalidCharacter : public Sysutils::Exception
{
	typedef Sysutils::Exception inherited;
	
public:
	__fastcall EUUInvalidCharacter(void);
public:
	/* Exception.CreateFmt */ __fastcall EUUInvalidCharacter(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EUUInvalidCharacter(int Ident) : Sysutils::Exception(Ident) { }
		
	/* Exception.CreateResFmt */ __fastcall EUUInvalidCharacter(int Ident, const System::TVarRec * Args
		, const int Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EUUInvalidCharacter(const System::AnsiString Msg, int AHelpContext
		) : Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EUUInvalidCharacter(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EUUInvalidCharacter(int Ident, int AHelpContext) : Sysutils::
		Exception(Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EUUInvalidCharacter(int Ident, const System::TVarRec * 
		Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext
		) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EUUInvalidCharacter(void) { }
	
};

class __declspec(delphiclass) TUUCode;
class __declspec(pascalimplementation) TUUCode : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	Classes::TStringList* StringList;
	Classes::TStream* Stream;
	bool A24Bits[361];
	TCodeMethod FCodeMethod;
	bool FCheckSums;
	Classes::TNotifyEvent FOnProgress;
	Classes::TNotifyEvent FOnStart;
	Classes::TNotifyEvent FOnEnd;
	void __fastcall SetCodeMethod(TCodeMethod Value);
	System::AnsiString __fastcall Generate60Bytes(const Byte * tb, Byte NumOfBytes);
	void __fastcall Generate45Bytes( System::ShortString &InS, void * A45Bytes, Word &BytesGenerated);
	Byte __fastcall ByteFromTable(char Ch);
	void __fastcall DoProgress(System::TObject* Sender);
	void __fastcall DoStart(System::TObject* Sender);
	void __fastcall DoEnd(System::TObject* Sender);
	
public:
	int Progress;
	int ProgressStep;
	bool Canceled;
	System::AnsiString Table;
	__fastcall TUUCode(Classes::TStream* AStream, Classes::TStringList* AStringList);
	void __fastcall Encode(void);
	void __fastcall Decode(void);
	__property TCodeMethod CodeMethod = {read=FCodeMethod, write=SetCodeMethod, default=0};
	__property bool CheckSums = {read=FCheckSums, write=FCheckSums, default=0};
	__property Classes::TNotifyEvent OnProgress = {read=FOnProgress, write=FOnProgress};
	__property Classes::TNotifyEvent OnStart = {read=FOnStart, write=FOnStart};
	__property Classes::TNotifyEvent OnEnd = {read=FOnEnd, write=FOnEnd};
public:
	/* TObject.Destroy */ __fastcall virtual ~TUUCode(void) { }
	
};

//-- var, const, procedure ---------------------------------------------------
#define MaxChars (Byte)(45)

}	/* namespace Uucode */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Uucode;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// UUCode
