//======================================================================
//
// FILEMON.h - include file for VxD FILEMON
//
// Copyright (C) 1996 Mark Russinovich and Bryce Cogswell
//
//======================================================================
#include <vtoolsc.h>

//----------------------------------------------------------------------
//                           D E F I N E S 
//----------------------------------------------------------------------
#define FILEMON_Major		1
#define FILEMON_Minor		0
#define FILEMON_DeviceID		UNDEFINED_DEVICE_ID
#define FILEMON_Init_Order	UNDEFINED_INIT_ORDER

// number of hash buckets
#define NUMHASH		0x100
#define HASHOBJECT(_filenumber)	(((ULONG)_filenumber)>>2)%NUMHASH

// mutex 
#define MUTEX_INIT(v)   v = Create_Semaphore(1)
#define MUTEX_P(v)      Wait_Semaphore( v, BLOCK_SVC_INTS )
#define MUTEX_V(v)      Signal_Semaphore( v )

// size of storage buffer in pages
#define STORESIZE       MAX_STORE/0x1000

//----------------------------------------------------------------------
//                        S T R U C T U R E S 
//----------------------------------------------------------------------

// Structure for our name hash table
typedef struct _nameentry {
   sfn_t                filenumber;
   PCHAR		FullName;
   struct _nameentry 	*Next;
} HASH_ENTRY, *PHASH_ENTRY;

// Structure for keeping linked lists of output buffers
typedef struct _store {
    ULONG		Len;
    struct _store *	Next;
    char		Data[ MAX_STORE ];
} STORE_BUF, *PSTORE_BUF;

 



