//======================================================================
// 
// Ioctlcmd.h
//
// Copyright (C) 1996 Mark Russinovich and Bryce Cogswell
//
// Common header file for device driver and GUI. Contains common
// data structure definitions and IOCTL command codes.
//
//======================================================================

// commands that the GUI can send the device driver
enum {
	REGMON_zerostats	= 1,
	REGMON_getstats	        = 2,
};


// format of a data entry
typedef struct {
	unsigned long	seq;
	char	text[0];
} ENTRY, *PENTRY;

// size of a storage buffer in bytes
#define MAX_STORE       64*0x1000

// define page size for use by GUI
#ifndef PAGE_SIZE
#define PAGE_SIZE 4096
#endif

